/* timeline.c generated by valac 0.56.17, the Vala compiler
 * generated from timeline.vala, do not modify */

/* GStreamer Instruments
 * Copyright (C) 2015 Kyrylo Polezhaiev <kirushyk@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_TIMELINE (timeline_get_type ())
#define TIMELINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMELINE, Timeline))
#define TIMELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMELINE, TimelineClass))
#define IS_TIMELINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMELINE))
#define IS_TIMELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMELINE))
#define TIMELINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMELINE, TimelineClass))

typedef struct _Timeline Timeline;
typedef struct _TimelineClass TimelineClass;
typedef struct _TimelinePrivate TimelinePrivate;
enum  {
	TIMELINE_0_PROPERTY,
	TIMELINE_NUM_PROPERTIES
};
static GParamSpec* timeline_properties[TIMELINE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
enum  {
	TIMELINE_INTERVAL_SELECTED_SIGNAL,
	TIMELINE_NUM_SIGNALS
};
static guint timeline_signals[TIMELINE_NUM_SIGNALS] = {0};

struct _Timeline {
	GtkDrawingArea parent_instance;
	TimelinePrivate * priv;
	gdouble x_duration;
};

struct _TimelineClass {
	GtkDrawingAreaClass parent_class;
};

struct _TimelinePrivate {
	gboolean dragging;
	gdouble x_begin;
	gdouble x_initial;
	gdouble x_end;
};

static gint Timeline_private_offset;
static gpointer timeline_parent_class = NULL;

VALA_EXTERN GType timeline_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Timeline, g_object_unref)
VALA_EXTERN void timeline_load (Timeline* self,
                    const gchar* path);
VALA_EXTERN gboolean timeline_update (Timeline* self);
VALA_EXTERN Timeline* timeline_new (void);
VALA_EXTERN Timeline* timeline_construct (GType object_type);
static gboolean timeline_real_draw (GtkWidget* base,
                             cairo_t* c);
static gboolean timeline_real_button_press_event (GtkWidget* base,
                                           GdkEventButton* event);
static gboolean timeline_real_button_release_event (GtkWidget* base,
                                             GdkEventButton* event);
static gboolean timeline_real_motion_notify_event (GtkWidget* base,
                                            GdkEventMotion* event);
static void timeline_redraw_canvas (Timeline* self);
static void g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void timeline_finalize (GObject * obj);
static GType timeline_get_type_once (void);

static inline gpointer
timeline_get_instance_private (Timeline* self)
{
	return G_STRUCT_MEMBER_P (self, Timeline_private_offset);
}

void
timeline_load (Timeline* self,
               const gchar* path)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	timeline_update (self);
}

Timeline*
timeline_construct (GType object_type)
{
	Timeline * self = NULL;
	self = (Timeline*) g_object_new (object_type, NULL);
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK) | GDK_POINTER_MOTION_MASK));
	self->priv->dragging = FALSE;
	self->x_duration = (gdouble) 0;
	self->priv->x_initial = self->x_duration;
	self->priv->x_begin = self->priv->x_initial;
	self->priv->x_end = (gdouble) 20000;
	gtk_widget_set_size_request ((GtkWidget*) self, 200, 80);
	return self;
}

Timeline*
timeline_new (void)
{
	return timeline_construct (TYPE_TIMELINE);
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

static gboolean
timeline_real_draw (GtkWidget* base,
                    cairo_t* c)
{
	Timeline * self;
	gint i = 0;
	gint width = 0;
	gint height = 0;
	gboolean result;
	self = (Timeline*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	i = 0;
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	cairo_set_source_rgb (c, 1.0, 1.0, 1.0);
	cairo_rectangle (c, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
	cairo_fill (c);
	cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
	cairo_set_line_width (c, 1.0);
	cairo_move_to (c, (gdouble) 0, (height / 2) + 0.5);
	cairo_line_to (c, (gdouble) width, (height / 2) + 0.5);
	{
		gdouble x = 0.0;
		x = 0.5;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean separator = FALSE;
				gint _tmp2_ = 0;
				gint _tmp3_ = 0;
				if (!_tmp0_) {
					gint _tmp1_;
					x += 20.0;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < ((gdouble) width))) {
					break;
				}
				separator = (i % 10) == 0;
				if (separator) {
					_tmp2_ = 10;
				} else {
					_tmp2_ = 30;
				}
				cairo_move_to (c, x, (gdouble) _tmp2_);
				if (separator) {
					_tmp3_ = 20;
				} else {
					_tmp3_ = 30;
				}
				cairo_line_to (c, x, (gdouble) (height - _tmp3_));
				if (separator) {
					gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					cairo_move_to (c, x + 5, (gdouble) 20);
					_tmp4_ = double_to_string (i * 0.1);
					_tmp5_ = _tmp4_;
					_tmp6_ = g_strconcat (_tmp5_, " s", NULL);
					_tmp7_ = _tmp6_;
					cairo_show_text (c, _tmp7_);
					_g_free0 (_tmp7_);
					_g_free0 (_tmp5_);
				}
			}
		}
	}
	cairo_move_to (c, self->priv->x_begin, (gdouble) 0);
	cairo_line_to (c, self->priv->x_begin, (gdouble) height);
	cairo_move_to (c, self->priv->x_end, (gdouble) 0);
	cairo_line_to (c, self->priv->x_end, (gdouble) height);
	cairo_stroke (c);
	cairo_set_source_rgba (c, 0.0, 0.0, 0.0, 0.25);
	cairo_rectangle (c, self->priv->x_begin, (gdouble) 0, self->priv->x_end - self->priv->x_begin, (gdouble) height);
	cairo_fill (c);
	cairo_set_source_rgba (c, 1.0, 1.0, 1.0, 0.75);
	cairo_rectangle (c, self->x_duration, (gdouble) 0, width - self->x_duration, (gdouble) height);
	cairo_fill (c);
	result = TRUE;
	return result;
}

static gboolean
timeline_real_button_press_event (GtkWidget* base,
                                  GdkEventButton* event)
{
	Timeline * self;
	gboolean result;
	self = (Timeline*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (!self->priv->dragging) {
		self->priv->dragging = TRUE;
		self->priv->x_initial = event->x;
	}
	result = FALSE;
	return result;
}

static gboolean
timeline_real_button_release_event (GtkWidget* base,
                                    GdkEventButton* event)
{
	Timeline * self;
	gboolean result;
	self = (Timeline*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (self->priv->dragging) {
		self->priv->dragging = FALSE;
		g_signal_emit (self, timeline_signals[TIMELINE_INTERVAL_SELECTED_SIGNAL], 0, self->priv->x_begin / 20.0f, self->priv->x_end / 20.0f);
	}
	result = FALSE;
	return result;
}

static gboolean
timeline_real_motion_notify_event (GtkWidget* base,
                                   GdkEventMotion* event)
{
	Timeline * self;
	gboolean result;
	self = (Timeline*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (self->priv->dragging) {
		if (event->x < self->priv->x_initial) {
			self->priv->x_begin = event->x;
			self->priv->x_end = self->priv->x_initial;
		} else {
			self->priv->x_begin = self->priv->x_initial;
			self->priv->x_end = event->x;
		}
		if (self->priv->x_begin > self->x_duration) {
			self->priv->x_begin = self->x_duration;
		}
		if (self->priv->x_end > self->x_duration) {
			self->priv->x_end = self->x_duration;
		}
		timeline_update (self);
	}
	result = FALSE;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
timeline_redraw_canvas (Timeline* self)
{
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	cairo_region_t* region = NULL;
	GdkWindow* _tmp3_;
	cairo_region_t* _tmp4_;
	GdkWindow* _tmp5_;
	cairo_region_t* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	window = _tmp1_;
	_tmp2_ = window;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (window);
		return;
	}
	_tmp3_ = window;
	_tmp4_ = gdk_window_get_clip_region (_tmp3_);
	region = _tmp4_;
	_tmp5_ = window;
	_tmp6_ = region;
	gdk_window_invalidate_region (_tmp5_, _tmp6_, TRUE);
	_cairo_region_destroy0 (region);
	_g_object_unref0 (window);
}

gboolean
timeline_update (Timeline* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	timeline_redraw_canvas (self);
	result = TRUE;
	return result;
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_DOUBLE) (gpointer data1, gdouble arg_1, gdouble arg_2, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_double (param_values + 1), g_value_get_double (param_values + 2), data2);
}

static void
timeline_class_init (TimelineClass * klass,
                     gpointer klass_data)
{
	timeline_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Timeline_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) timeline_real_draw;
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) timeline_real_button_press_event;
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) timeline_real_button_release_event;
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) timeline_real_motion_notify_event;
	G_OBJECT_CLASS (klass)->finalize = timeline_finalize;
	timeline_signals[TIMELINE_INTERVAL_SELECTED_SIGNAL] = g_signal_new ("interval-selected", TYPE_TIMELINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
}

static void
timeline_instance_init (Timeline * self,
                        gpointer klass)
{
	self->priv = timeline_get_instance_private (self);
}

static void
timeline_finalize (GObject * obj)
{
	Timeline * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIMELINE, Timeline);
	G_OBJECT_CLASS (timeline_parent_class)->finalize (obj);
}

static GType
timeline_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TimelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Timeline), 0, (GInstanceInitFunc) timeline_instance_init, NULL };
	GType timeline_type_id;
	timeline_type_id = g_type_register_static (gtk_drawing_area_get_type (), "Timeline", &g_define_type_info, 0);
	Timeline_private_offset = g_type_add_instance_private (timeline_type_id, sizeof (TimelinePrivate));
	return timeline_type_id;
}

GType
timeline_get_type (void)
{
	static volatile gsize timeline_type_id__once = 0;
	if (g_once_init_enter (&timeline_type_id__once)) {
		GType timeline_type_id;
		timeline_type_id = timeline_get_type_once ();
		g_once_init_leave (&timeline_type_id__once, timeline_type_id);
	}
	return timeline_type_id__once;
}

